#pragma once

#include <ArmarXCore/core/Component.h>

#include <RobotAPI/interface/core/articulated_object/provider.h>
#include <RobotAPI/interface/core/articulated_object/topic.h>


namespace armarx::plugins
{

    class ArticulatedObjectProviderPlugin : public ComponentPlugin
    {
    public:

        using ComponentPlugin::ComponentPlugin;

        void postCreatePropertyDefinitions(PropertyDefinitionsPtr& properties) override;

        void preOnInitComponent() override;
        void preOnConnectComponent() override;
        void postOnConnectComponent() override;

        articulated_object::ArticulatedObjectTopicPrx createArticulatedObjectTopic();


    private:

        static constexpr const char* propertyName = "ArticulatedObjectTopicName";

    };

}  // namespace armarx::plugins


namespace armarx::articulated_object
{

    /**
     * @brief Provides an `articulated_object::ObjectPoseTopicPrx objectPoseTopic` as member variable.
     */
    class ArticulatedObjectProviderPluginUser :
        virtual public ManagedIceObject
        , virtual public provider::ArticulatedObjectStateProvider
    {
    public:

        ArticulatedObjectProviderPluginUser();

        /// Implement to process object requests (empty default implementation).
        // articulated_object::provider::RequestObjectsOutput requestObjects(const articulated_object::provider::RequestObjectsInput& input, const Ice::Current&) override;

        provider::TrackingRequestResponse trackObjects(const provider::TrackingRequest&, const ::Ice::Current& = ::Ice::emptyCurrent) override;

        ArticulatedObjectTopicPrx createArticulatedObjectTopic();

        ArticulatedObjectTopicPrx articulatedObjectTopic;


    private:

        armarx::plugins::ArticulatedObjectProviderPlugin* plugin = nullptr;

    };

}  // namespace armarx::articulated_object
