#include "EntitySnapshot.h"

#include <ArmarXCore/core/exceptions/local/ExpressionException.h>

#include "error.h"


namespace armarx::armem::ltm
{

    wm::EntitySnapshot EntitySnapshot::convert() const
    {
        wm::EntitySnapshot m;
        for (const auto& s : _container)
        {
            m.addInstance(s.convert());
        }
        return m;
    }

    void EntitySnapshot::setTo(const wm::EntitySnapshot& m)
    {
        // We remove the contente here and reset it with new values
        _container.clear();

        int i = 0;
        for (const auto& s : m.container())
        {
            auto wms = _container.emplace_back(id().withInstanceIndex(i++));
            wms.setTo(s);
        }
    }
}
