#pragma once

#include "../base/EntitySnapshotBase.h"

#include "EntityInstance.h"
#include "detail/CopyWithoutData.h"


namespace armarx::armem::wm
{

    /**
     * @brief Data of an entity at one point in time.
     */
    class EntitySnapshot :
        public base::EntitySnapshotBase<EntityInstance, EntitySnapshot>,
        public detail::CopyWithoutData<EntitySnapshot>
    {
        using Base = base::EntitySnapshotBase<EntityInstance, EntitySnapshot>;

    public:

        using Base::EntitySnapshotBase;
        using Base::operator=;


    protected:

        virtual void _copySelfWithoutData(EntitySnapshot& other) const override;

    };
}
