#pragma once

#include "BaseQueryProcessor.h"
#include "../base/MemoryQueryProcessorBase.h"

#include "../../../core/longtermmemory/Memory.h"

#include "CoreSegmentQueryProcessor.h"

namespace armarx::armem::ltm::query_proc
{
    /**
     * @brief Handles memory queries.
     */
    class MemoryQueryProcessor :
        virtual public BaseQueryProcessor<ltm::Memory, armem::query::data::MemoryQuery>,
        virtual public base::query_proc::MemoryQueryProcessorBase<ltm::Memory>
    {
        using Base = BaseQueryProcessor<ltm::Memory, armem::query::data::MemoryQuery>;

    public:
        MemoryQueryProcessor() :
            Base()
        {}

    protected:
        virtual CoreSegmentT coreSegmentProcessorProcess(const armem::query::data::CoreSegmentQuerySeq& q, const CoreSegmentT& s) const override
        {
            return coreSegmentProcessor.process(q, s);
        }

    private:
        CoreSegmentQueryProcessor coreSegmentProcessor;
    };
}
