#pragma once

// these types should be core types

#include <map>
#include <vector>

#include <Eigen/Geometry>

#include <IceUtil/Time.h>

#include <ArmarXCore/core/PackagePath.h>

namespace armarx::armem
{

    struct RobotDescription
    {
        // IceUtil::Time timestamp;

        std::string name;
        PackagePath xml;

    };


    struct RobotState
    {
        IceUtil::Time timestamp;

        Eigen::Affine3f globalPose;
        std::map<std::string, float> jointMap;
    };

    struct Robot
    {
        RobotDescription description;
        std::string instance;

        RobotState config;

        IceUtil::Time timestamp;
    };

    namespace articulated_object
    {
        using ArticulatedObjectDescription = RobotDescription;

        using ArticulatedObject = Robot;
        using ArticulatedObjects = std::vector<ArticulatedObject>;
    }

}  // namespace armarx::armem